function [Out,bDs]=setMatProd03(N,verbose,varargin)
  assert( ismember(length(N),[1,3]) )
  p = inputParser;
  %p.KeepUnmatched=true; 
  p.addParamValue('fprintf',@(varargin) fprintf(varargin{:}));
  p.addParamValue('lclass','double');
  p.addParamValue('rclass','double');
  p.addParamValue('lcomplex',false,@islogical);
  p.addParamValue('rcomplex',false,@islogical);
  p.parse(varargin{:});
  R=p.Results;
  R.lclass=lower(R.lclass);R.rclass=lower(R.rclass);
  Fprintf=R.fprintf;
  if length(N)==1
    m=N;n=N;p=N; % square matrices
  else
    m=N(1);n=N(2);p=N(3);
  end
  
  X=genMat(m,n,R.lclass,R.lcomplex);
  Y=genMat(n,p,R.rclass,R.rcomplex);
  
  if verbose
    if isreal(X), name=class(X); else, name=['complex ',class(X)]; end
    Fprintf('# 1st input parameter: m-by-n matrix [%s]\n',name)
    if isreal(Y), name=class(Y); else, name=['complex ',class(Y)]; end
    Fprintf('# 2nd input parameter: n-by-p matrix [%s]\n',name)
  end
  
  bDs(1)=fc_bench.bdata('m',m,'%d',7);
  bDs(2)=fc_bench.bdata('n',n,'%d',7);
  bDs(3)=fc_bench.bdata('p',p,'%d',7);
  Out={X,Y};
end

function V=genMat(m,n,classname,iscomplex)
  V=randn(m,n,classname);
  if iscomplex,  V=complex(V,randn(m,n,classname));end
end
